package org.processmining.big4prom.plugins;


	import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Set;

import org.jgrapht.DirectedGraph;
import org.jgrapht.graph.DefaultEdge;
import org.processmining.big4prom.models.ModelResult;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

	@Plugin(name = "Export IG set as IGS (.igs)", returnLabels = {}, returnTypes = {}, parameterLabels = {
			"Instance Graphs Set", "File" }, userAccessible = true)
	@UIExportPlugin(description = "Export IG set as IGS", extension = "igs")
public class ExportIGSet {
		@PluginVariant(variantLabel = "IGS (.igs)", requiredParameterLabels = { 0, 1 })
		public void exportIGSet(PluginContext context,ModelResult res, File file){
			FileWriter writer = null;
			HashMap<Integer, DirectedGraph<String, DefaultEdge>> graphMap=res.getRes();
			try {
				writer = new FileWriter(file.getAbsolutePath(), false);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			for(int i=1; i<res.getRes().size()+1;i++){
				try {
					writer.write("#\n");
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			DirectedGraph<String, DefaultEdge> graph1=graphMap.get(i);
			Set<String> posVertexes = graph1.vertexSet();
			for (String posVertex : posVertexes) {
				
						try {
							
							writer.write("v "+posVertex +"\n");
							
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					
				
			}
			Set<DefaultEdge> posEdges = graph1.edgeSet();
			for (DefaultEdge posEdge : posEdges) {
				//String edgeLabel="[label=\""+edgeLabel+"\",color=black,fontcolor=black]";
				try {
					String source=graph1.getEdgeSource(posEdge);
					String target= graph1.getEdgeTarget(posEdge);
					writer.write("e "+source+" "+target+ "\n");
					
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
		}
			try {
				writer.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	}


