package org.processmining.big4prom.plugins;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;

import org.jgrapht.DirectedGraph;
import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultEdge;
import org.processmining.big4prom.models.ModelResult;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;

@Plugin(name = "Import IG from IGS (.igs)", returnLabels = { "Instance Graph" }, returnTypes = { ModelResult.class }, parameterLabels = {"Filename"})
@UIImportPlugin(description = "Import IG from IGS (.igs)", extensions = { "igs"})
public class ImportIGSet extends AbstractImportPlugin {

	protected ModelResult importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		System.out.println(filename);
		BufferedReader in = new BufferedReader(new InputStreamReader(input));
		String line = null;
		int i=0;
		HashMap<Integer, DirectedGraph<String, org.jgrapht.graph.DefaultEdge>> model= new HashMap<Integer, DirectedGraph<String, org.jgrapht.graph.DefaultEdge>>();
		DirectedGraph<String, org.jgrapht.graph.DefaultEdge> graph = null;
		while((line = in.readLine()) != null) {
		   if(line.startsWith("#")){
			   if(graph!=null)
				   model.put(i, graph);
			   i++;
			   graph= new DefaultDirectedGraph<String, DefaultEdge>(
						DefaultEdge.class);
		   }
		   else if(line.startsWith("v")){
			   String[] lineTokens=line.split(" ");
			   graph.addVertex(lineTokens[1]);
		   }
		   else if(line.startsWith("e")){
			   String[] lineTokens=line.split(" ");
			   String source=lineTokens[1];
			   String target=lineTokens[2];
			   graph.addEdge(source, target);
		   }
			   
		   
		}
		ModelResult result= new ModelResult(model);
		return result;
	}

}
